diff --git a/gnome-session/gsm-manager.c b/gnome-session/gsm-manager.c
index b7f1788e..743a372e 100644
--- a/gnome-session/gsm-manager.c
+++ b/gnome-session/gsm-manager.c
@@ -1353,15 +2446,12 @@ gsm_manager_shutdown (GsmExportedManager    *skeleton,
                 return TRUE;
         }
 
-        task = g_task_new (manager, manager->end_session_cancellable, (GAsyncReadyCallback) complete_end_session_task, invocation);
+        task = g_task_new (manager, priv->end_session_cancellable, (GAsyncReadyCallback) complete_end_session_task, invocation);
 
-        manager->pending_end_session_tasks = g_slist_prepend (manager->pending_end_session_tasks,
+        priv->pending_end_session_tasks = g_slist_prepend (priv->pending_end_session_tasks,
                                                                     task);
 
-        g_debug ("GsmManager: requesting shutdown");
-
-        manager->logout_type = GSM_MANAGER_LOGOUT_SHUTDOWN;
-        end_phase (manager);
+        request_shutdown (manager);
 
         return TRUE;
 }
@@ -1371,11 +2461,12 @@ gsm_manager_reboot (GsmExportedManager    *skeleton,
                     GDBusMethodInvocation *invocation,
                     GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GTask *task;
 
         g_debug ("GsmManager: Reboot called");
 
-        if (manager->phase < GSM_MANAGER_PHASE_RUNNING) {
+        if (priv->phase < GSM_MANAGER_PHASE_RUNNING) {
                 g_dbus_method_invocation_return_error (invocation,
                                                        GSM_MANAGER_ERROR,
                                                        GSM_MANAGER_ERROR_NOT_IN_RUNNING,
@@ -1391,15 +2482,12 @@ gsm_manager_reboot (GsmExportedManager    *skeleton,
                 return TRUE;
         }
 
-        task = g_task_new (manager, manager->end_session_cancellable, (GAsyncReadyCallback) complete_end_session_task, invocation);
+        task = g_task_new (manager, priv->end_session_cancellable, (GAsyncReadyCallback) complete_end_session_task, invocation);
 
-        manager->pending_end_session_tasks = g_slist_prepend (manager->pending_end_session_tasks,
+        priv->pending_end_session_tasks = g_slist_prepend (priv->pending_end_session_tasks,
                                                                     task);
 
-        g_debug ("GsmManager: requesting reboot");
-
-        manager->logout_type = GSM_MANAGER_LOGOUT_REBOOT;
-        end_phase (manager);
+        request_reboot (manager);
 
         return TRUE;
 }
@@ -1409,15 +2497,16 @@ gsm_manager_can_shutdown (GsmExportedManager    *skeleton,
                           GDBusMethodInvocation *invocation,
                           GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         gboolean shutdown_available;
 
         g_debug ("GsmManager: CanShutdown called");
 
         shutdown_available = !_log_out_is_locked_down (manager) &&
-                (gsm_system_can_stop (manager->system)
-                 || gsm_system_can_restart (manager->system)
-                 || gsm_system_can_suspend (manager->system)
-                 || gsm_system_can_hibernate (manager->system));
+                (gsm_system_can_stop (priv->system)
+                 || gsm_system_can_restart (priv->system)
+                 || gsm_system_can_suspend (priv->system)
+                 || gsm_system_can_hibernate (priv->system));
 
         gsm_exported_manager_complete_can_shutdown (skeleton, invocation, shutdown_available);
 
@@ -1429,12 +2518,13 @@ gsm_manager_can_reboot_to_firmware_setup (GsmExportedManager    *skeleton,
                                           GDBusMethodInvocation *invocation,
                                           GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         gboolean reboot_to_firmware_available;
 
         g_debug ("GsmManager: CanRebootToFirmwareSetup called");
 
         reboot_to_firmware_available = !_log_out_is_locked_down (manager) &&
-                gsm_system_can_restart_to_firmware_setup (manager->system);
+                gsm_system_can_restart_to_firmware_setup (priv->system);
 
         gsm_exported_manager_complete_can_reboot_to_firmware_setup (skeleton, invocation, reboot_to_firmware_available);
 
@@ -1447,9 +2537,11 @@ gsm_manager_set_reboot_to_firmware_setup (GsmExportedManager    *skeleton,
                                           gboolean               enable,
                                           GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: SetRebootToFirmwareSetup called");
 
-        gsm_system_set_restart_to_firmware_setup (manager->system, enable);
+        gsm_system_set_restart_to_firmware_setup (priv->system, enable);
 
         gsm_exported_manager_complete_set_reboot_to_firmware_setup (skeleton, invocation);
 
@@ -1463,11 +2555,13 @@ gsm_manager_setenv (GsmExportedManager    *skeleton,
                     const char            *value,
                     GsmManager            *manager)
 {
-        if (manager->phase > GSM_MANAGER_PHASE_INITIALIZATION) {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->phase > GSM_MANAGER_PHASE_INITIALIZATION) {
                 g_dbus_method_invocation_return_error (invocation,
                                                        GSM_MANAGER_ERROR,
                                                        GSM_MANAGER_ERROR_NOT_IN_INITIALIZATION,
-                                                       "Setenv interface is only available during the Initialization phase");
+                                                       "Setenv interface is only available during the DisplayServer and Initialization phase");
         } else {
                 gsm_util_setenv (variable, value);
                 gsm_exported_manager_complete_setenv (skeleton, invocation);
@@ -1481,23 +2575,32 @@ gsm_manager_initialized (GsmExportedManager    *skeleton,
                          GDBusMethodInvocation *invocation,
                          GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
         /* Signaled by helper when gnome-session-initialized.target is reached. */
-        if (manager->systemd_initialized) {
+        if (!priv->systemd_managed) {
+                g_dbus_method_invocation_return_error (invocation,
+                                                       GSM_MANAGER_ERROR,
+                                                       GSM_MANAGER_ERROR_GENERAL,
+                                                       "Initialized interface is only available when gnome-session is managed by systemd");
+        } else if (priv->systemd_initialized) {
                 g_dbus_method_invocation_return_error (invocation,
                                                        GSM_MANAGER_ERROR,
                                                        GSM_MANAGER_ERROR_NOT_IN_INITIALIZATION,
                                                        "Systemd initialization was already signaled");
-        } else if (manager->phase > GSM_MANAGER_PHASE_INITIALIZATION) {
+        } else if (priv->phase > GSM_MANAGER_PHASE_INITIALIZATION) {
                 g_dbus_method_invocation_return_error (invocation,
                                                        GSM_MANAGER_ERROR,
                                                        GSM_MANAGER_ERROR_NOT_IN_INITIALIZATION,
                                                        "Initialized interface is only available during startup");
         } else {
-                manager->systemd_initialized = TRUE;
+                priv->systemd_initialized = TRUE;
 
-                g_assert (manager->phase == GSM_MANAGER_PHASE_INITIALIZATION);
-                manager->phase++;
-                start_phase (manager);
+                if (priv->manager_initialized) {
+                        g_assert (priv->phase == GSM_MANAGER_PHASE_INITIALIZATION);
+                        priv->phase++;
+                        start_phase (manager);
+                }
 
                 gsm_exported_manager_complete_initialized (skeleton, invocation);
         }
@@ -1574,7 +2677,9 @@ gsm_manager_initialization_error (GsmExportedManager    *skeleton,
                                   gboolean               fatal,
                                   GsmManager            *manager)
 {
-        if (manager->phase != GSM_MANAGER_PHASE_INITIALIZATION) {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->phase != GSM_MANAGER_PHASE_INITIALIZATION) {
                 g_dbus_method_invocation_return_error (invocation,
                                                        GSM_MANAGER_ERROR,
                                                        GSM_MANAGER_ERROR_NOT_IN_INITIALIZATION,
@@ -1588,12 +2693,29 @@ gsm_manager_initialization_error (GsmExportedManager    *skeleton,
         return TRUE;
 }
 
+static void
+user_logout (GsmManager           *manager,
+             GsmManagerLogoutMode  mode)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+                priv->logout_mode = mode;
+                end_session_or_show_shell_dialog (manager);
+                return;
+        }
+
+        request_logout (manager, mode);
+}
+
 gboolean
 gsm_manager_logout (GsmManager *manager,
                     guint logout_mode,
                     GError **error)
 {
-        if (manager->phase < GSM_MANAGER_PHASE_RUNNING) {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+
+        if (priv->phase < GSM_MANAGER_PHASE_RUNNING) {
                 g_set_error (error,
                              GSM_MANAGER_ERROR,
                              GSM_MANAGER_ERROR_NOT_IN_RUNNING,
@@ -1611,13 +2733,9 @@ gsm_manager_logout (GsmManager *manager,
 
         switch (logout_mode) {
         case GSM_MANAGER_LOGOUT_MODE_NORMAL:
-                g_debug ("GsmManager: requesting logout");
-                break;
         case GSM_MANAGER_LOGOUT_MODE_NO_CONFIRMATION:
-                g_debug ("GsmManager: requesting no-confirmation logout");
-                break;
         case GSM_MANAGER_LOGOUT_MODE_FORCE:
-                g_debug ("GsmManager: requesting forced logout");
+                user_logout (manager, logout_mode);
                 break;
 
         default:
@@ -1630,18 +2748,6 @@ gsm_manager_logout (GsmManager *manager,
                 return FALSE;
         }
 
-        manager->logout_mode = logout_mode;
-
-        if (manager->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
-                /* Someone can upgrade a normal logout to a forced logout
-                 * while we're busy prompting. In this case, re-evaluate */
-                end_session_or_show_shell_dialog (manager);
-                return TRUE;
-        }
-
-        manager->logout_type = GSM_MANAGER_LOGOUT_LOGOUT;
-        end_phase (manager);
-
         return TRUE;
 }
 
@@ -1668,17 +2774,21 @@ static gboolean
 gsm_manager_register_client (GsmExportedManager    *skeleton,
                              GDBusMethodInvocation *invocation,
                              const char            *app_id,
-                             const char            *ignored, /* was startup_id */
+                             const char            *startup_id,
                              GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        char       *new_startup_id;
         const char *sender;
         GsmClient  *client;
+        GsmApp     *app;
 
+        app = NULL;
         client = NULL;
 
-        g_debug ("GsmManager: RegisterClient %s", app_id);
+        g_debug ("GsmManager: RegisterClient %s", startup_id);
 
-        if (manager->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
+        if (priv->phase >= GSM_MANAGER_PHASE_QUERY_END_SESSION) {
                 g_debug ("Unable to register client: shutting down");
 
                 g_dbus_method_invocation_return_error (invocation,
@@ -1688,8 +2798,39 @@ gsm_manager_register_client (GsmExportedManager    *skeleton,
                 return TRUE;
         }
 
+        if (IS_STRING_EMPTY (startup_id)) {
+                new_startup_id = gsm_util_generate_startup_id ();
+        } else {
+
+                client = (GsmClient *)gsm_store_find (priv->clients,
+                                                      (GsmStoreFunc)_client_has_startup_id,
+                                                      (char *)startup_id);
+                /* We can't have two clients with the same startup id. */
+                if (client != NULL) {
+                        g_debug ("Unable to register client: already registered");
+
+                        g_dbus_method_invocation_return_error (invocation,
+                                                               GSM_MANAGER_ERROR,
+                                                               GSM_MANAGER_ERROR_ALREADY_REGISTERED,
+                                                               "Unable to register client");
+                        return TRUE;
+                }
+
+                new_startup_id = g_strdup (startup_id);
+        }
+
+        g_debug ("GsmManager: Adding new client %s to session", new_startup_id);
+
+        if (app == NULL && !IS_STRING_EMPTY (startup_id)) {
+                app = find_app_for_startup_id (manager, startup_id);
+        }
+        if (app == NULL && !IS_STRING_EMPTY (app_id)) {
+                /* try to associate this app id with a known app */
+                app = find_app_for_app_id (manager, app_id);
+        }
+
         sender = g_dbus_method_invocation_get_sender (invocation);
-        client = gsm_client_new (app_id, sender);
+        client = gsm_dbus_client_new (new_startup_id, sender);
         if (client == NULL) {
                 g_debug ("Unable to create client");
 
@@ -1700,14 +2841,29 @@ gsm_manager_register_client (GsmExportedManager    *skeleton,
                 return TRUE;
         }
 
-        gsm_store_add (manager->clients, gsm_client_peek_id (client), G_OBJECT (client));
-        g_object_unref (client); /* the store will own the ref */
+        gsm_store_add (priv->clients, gsm_client_peek_id (client), G_OBJECT (client));
+        /* the store will own the ref */
+        g_object_unref (client);
 
         g_signal_connect (client,
                           "disconnected",
                           G_CALLBACK (on_client_disconnected),
                           manager);
 
+        if (app != NULL) {
+                gsm_client_set_app_id (client, gsm_app_peek_app_id (app));
+                gsm_app_set_registered (app, TRUE);
+        } else {
+                /* if an app id is specified store it in the client
+                   so we can save it later */
+                gsm_client_set_app_id (client, app_id);
+        }
+
+        gsm_client_set_status (client, GSM_CLIENT_REGISTERED);
+
+        g_assert (new_startup_id != NULL);
+        g_free (new_startup_id);
+
         gsm_exported_manager_complete_register_client (skeleton, invocation, gsm_client_peek_id (client));
 
         return TRUE;
@@ -1719,8 +2875,28 @@ gsm_manager_unregister_client (GsmExportedManager    *skeleton,
                                const char            *client_id,
                                GsmManager            *manager)
 {
-        g_debug ("GsmManager: UnregisterClient %s (ignoring)", client_id);
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GsmClient *client;
+
+        g_debug ("GsmManager: UnregisterClient %s", client_id);
+
+        client = (GsmClient *)gsm_store_lookup (priv->clients, client_id);
+        if (client == NULL) {
+                g_debug ("Unable to unregister client: not registered");
+
+                g_dbus_method_invocation_return_error (invocation,
+                                                       GSM_MANAGER_ERROR,
+                                                       GSM_MANAGER_ERROR_NOT_REGISTERED,
+                                                       "Unable to unregister client");
+                return TRUE;
+        }
+
+        /* don't disconnect client here, only change the status.
+           Wait until it leaves the bus before disconnecting it */
+        gsm_client_set_status (client, GSM_CLIENT_UNREGISTERED);
+
         gsm_exported_manager_complete_unregister_client (skeleton, invocation);
+
         return TRUE;
 }
 
@@ -1728,41 +2904,62 @@ static gboolean
 gsm_manager_inhibit (GsmExportedManager    *skeleton,
                      GDBusMethodInvocation *invocation,
                      const char            *app_id,
-                     guint                  unused, /* Was an X window ID */
+                     guint                  toplevel_xid,
                      const char            *reason,
                      guint                  flags,
                      GsmManager            *manager)
 {
-        const char *validation_error = NULL;
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitor *inhibitor;
         guint         cookie;
 
-        g_debug ("GsmManager: Inhibit app_id=%s reason=%s flags=%u",
-                 app_id, reason, flags);
+        g_debug ("GsmManager: Inhibit xid=%u app_id=%s reason=%s flags=%u",
+                 toplevel_xid,
+                 app_id,
+                 reason,
+                 flags);
 
-        if (manager->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE)
-                validation_error = "Forced logout cannot be inhibited";
-        else if (IS_STRING_EMPTY (reason))
-                validation_error = "Reason not specified";
-        else if (flags == 0)
-                validation_error = "Invalid inhibit flags";
+        if (priv->logout_mode == GSM_MANAGER_LOGOUT_MODE_FORCE) {
+                GError *new_error;
 
-        if (validation_error != NULL) {
-                g_debug ("GsmManager: Unable to inhibit: %s", validation_error);
-                g_dbus_method_invocation_return_error (invocation,
-                                                       GSM_MANAGER_ERROR,
-                                                       GSM_MANAGER_ERROR_GENERAL,
-                                                       "%s", validation_error);
+                new_error = g_error_new (GSM_MANAGER_ERROR,
+                                         GSM_MANAGER_ERROR_GENERAL,
+                                         "Forced logout cannot be inhibited");
+                g_debug ("GsmManager: Unable to inhibit: %s", new_error->message);
+                g_dbus_method_invocation_take_error (invocation, new_error);
+                return TRUE;
+        }
+
+        if (IS_STRING_EMPTY (reason)) {
+                GError *new_error;
+
+                new_error = g_error_new (GSM_MANAGER_ERROR,
+                                         GSM_MANAGER_ERROR_GENERAL,
+                                         "Reason not specified");
+                g_debug ("GsmManager: Unable to inhibit: %s", new_error->message);
+                g_dbus_method_invocation_take_error (invocation, new_error);
+                return TRUE;
+        }
+
+        if (flags == 0) {
+                GError *new_error;
+
+                new_error = g_error_new (GSM_MANAGER_ERROR,
+                                         GSM_MANAGER_ERROR_GENERAL,
+                                         "Invalid inhibit flags");
+                g_debug ("GsmManager: Unable to inhibit: %s", new_error->message);
+                g_dbus_method_invocation_take_error (invocation, new_error);
                 return TRUE;
         }
 
         cookie = _generate_unique_cookie (manager);
         inhibitor = gsm_inhibitor_new (app_id,
+                                       toplevel_xid,
                                        flags,
                                        reason,
                                        g_dbus_method_invocation_get_sender (invocation),
                                        cookie);
-        gsm_store_add (manager->inhibitors, gsm_inhibitor_peek_id (inhibitor), G_OBJECT (inhibitor));
+        gsm_store_add (priv->inhibitors, gsm_inhibitor_peek_id (inhibitor), G_OBJECT (inhibitor));
         g_object_unref (inhibitor);
 
         gsm_exported_manager_complete_inhibit (skeleton, invocation, cookie);
@@ -1776,11 +2973,12 @@ gsm_manager_uninhibit (GsmExportedManager    *skeleton,
                        guint                  cookie,
                        GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitor *inhibitor;
 
         g_debug ("GsmManager: Uninhibit %u", cookie);
 
-        inhibitor = (GsmInhibitor *)gsm_store_find (manager->inhibitors,
+        inhibitor = (GsmInhibitor *)gsm_store_find (priv->inhibitors,
                                                     (GsmStoreFunc)_find_by_cookie,
                                                     &cookie);
         if (inhibitor == NULL) {
@@ -1794,13 +2992,14 @@ gsm_manager_uninhibit (GsmExportedManager    *skeleton,
                 return TRUE;
         }
 
-        g_debug ("GsmManager: removing inhibitor %s reason '%s' %u connection %s",
+        g_debug ("GsmManager: removing inhibitor %s %u reason '%s' %u connection %s",
                  gsm_inhibitor_peek_app_id (inhibitor),
+                 gsm_inhibitor_peek_toplevel_xid (inhibitor),
                  gsm_inhibitor_peek_reason (inhibitor),
                  gsm_inhibitor_peek_flags (inhibitor),
                  gsm_inhibitor_peek_bus_name (inhibitor));
 
-        gsm_store_remove (manager->inhibitors, gsm_inhibitor_peek_id (inhibitor));
+        gsm_store_remove (priv->inhibitors, gsm_inhibitor_peek_id (inhibitor));
 
         gsm_exported_manager_complete_uninhibit (skeleton, invocation);
 
@@ -1813,14 +3012,15 @@ gsm_manager_is_inhibited (GsmExportedManager    *skeleton,
                           guint                  flags,
                           GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GsmInhibitor *inhibitor;
         gboolean is_inhibited;
 
-        if (manager->inhibitors == NULL
-            || gsm_store_size (manager->inhibitors) == 0) {
+        if (priv->inhibitors == NULL
+            || gsm_store_size (priv->inhibitors) == 0) {
                 is_inhibited = FALSE;
         } else {
-                inhibitor = (GsmInhibitor *) gsm_store_find (manager->inhibitors,
+                inhibitor = (GsmInhibitor *) gsm_store_find (priv->inhibitors,
                                                              (GsmStoreFunc)inhibitor_has_flag,
                                                              GUINT_TO_POINTER (flags));
                 if (inhibitor == NULL) {
@@ -1844,15 +3044,37 @@ listify_store_ids (char       *id,
         return FALSE;
 }
 
+static gboolean
+gsm_manager_get_clients (GsmExportedManager    *skeleton,
+                         GDBusMethodInvocation *invocation,
+                         GsmManager            *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GPtrArray *clients;
+
+        clients = g_ptr_array_new_with_free_func (g_free);
+        gsm_store_foreach (priv->clients,
+                           (GsmStoreFunc) listify_store_ids,
+                           &clients);
+        g_ptr_array_add (clients, NULL);
+
+        gsm_exported_manager_complete_get_clients (skeleton, invocation,
+                                                   (const gchar * const *) clients->pdata);
+        g_ptr_array_unref (clients);
+
+        return TRUE;
+}
+
 static gboolean
 gsm_manager_get_inhibitors (GsmExportedManager    *skeleton,
                             GDBusMethodInvocation *invocation,
                             GsmManager            *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GPtrArray *inhibitors;
 
         inhibitors = g_ptr_array_new_with_free_func (g_free);
-        gsm_store_foreach (manager->inhibitors,
+        gsm_store_foreach (priv->inhibitors,
                            (GsmStoreFunc) listify_store_ids,
                            &inhibitors);
         g_ptr_array_add (inhibitors, NULL);
@@ -1864,18 +3086,54 @@ gsm_manager_get_inhibitors (GsmExportedManager    *skeleton,
         return TRUE;
 }
 
+static gboolean
+_app_has_autostart_condition (const char *id,
+                              GsmApp     *app,
+                              const char *condition)
+{
+        gboolean has;
+        gboolean disabled;
+
+        has = gsm_app_has_autostart_condition (app, condition);
+        disabled = gsm_app_peek_is_disabled (app);
+
+        return has && !disabled;
+}
+
+static gboolean
+gsm_manager_is_autostart_condition_handled (GsmExportedManager    *skeleton,
+                                            GDBusMethodInvocation *invocation,
+                                            const char            *condition,
+                                            GsmManager            *manager)
+{
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
+        GsmApp *app;
+        gboolean handled;
+
+        app = (GsmApp *) gsm_store_find (priv->apps,(
+                                         GsmStoreFunc) _app_has_autostart_condition,
+                                         (char *)condition);
+
+        if (app != NULL) {
+                handled = TRUE;
+        } else {
+                handled = FALSE;
+        }
+
+        gsm_exported_manager_complete_is_autostart_condition_handled (skeleton, invocation, handled);
+
+        return TRUE;
+}
+
 static gboolean
 gsm_manager_is_session_running (GsmExportedManager    *skeleton,
                                 GDBusMethodInvocation *invocation,
                                 GsmManager            *manager)
 {
-        gboolean running;
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
 
-        running = (manager->phase == GSM_MANAGER_PHASE_APPLICATION ||
-                   manager->phase == GSM_MANAGER_PHASE_RUNNING ||
-                   manager->phase == GSM_MANAGER_PHASE_QUERY_END_SESSION);
-
-        gsm_exported_manager_complete_is_session_running (skeleton, invocation, running);
+        gsm_exported_manager_complete_is_session_running (skeleton, invocation,
+                                                          priv->phase == GSM_MANAGER_PHASE_RUNNING);
         return TRUE;
 }
 
@@ -1885,15 +3143,21 @@ on_session_connection_closed (GDBusConnection *connection,
                               GError *error,
                               gpointer user_data)
 {
-        GsmManager *manager = GSM_MANAGER (user_data);
+        GsmManager *manager;
+        GsmManagerPrivate *priv;
+
+        manager = GSM_MANAGER (user_data);
+        priv = gsm_manager_get_instance_private (manager);
+
         g_debug ("GsmManager: dbus disconnected; disconnecting dbus clients...");
-        manager->dbus_disconnected = TRUE;
+        priv->dbus_disconnected = TRUE;
         remove_clients_for_connection (manager, NULL);
 }
 
 static gboolean
 register_manager (GsmManager *manager)
 {
+        GsmManagerPrivate *priv = gsm_manager_get_instance_private (manager);
         GDBusConnection *connection;
         GsmExportedManager *skeleton;
         GError *error = NULL;
@@ -1923,6 +3187,8 @@ register_manager (GsmManager *manager)
                           G_CALLBACK (gsm_manager_can_reboot_to_firmware_setup), manager);
         g_signal_connect (skeleton, "handle-can-shutdown",
                           G_CALLBACK (gsm_manager_can_shutdown), manager);
+        g_signal_connect (skeleton, "handle-get-clients",
+                          G_CALLBACK (gsm_manager_get_clients), manager);
         g_signal_connect (skeleton, "handle-get-inhibitors",
                           G_CALLBACK (gsm_manager_get_inhibitors), manager);
         g_signal_connect (skeleton, "handle-get-locale",
@@ -1931,6 +3197,8 @@ register_manager (GsmManager *manager)
                           G_CALLBACK (gsm_manager_inhibit), manager);
         g_signal_connect (skeleton, "handle-initialization-error",
                           G_CALLBACK (gsm_manager_initialization_error), manager);
+        g_signal_connect (skeleton, "handle-is-autostart-condition-handled",
+                          G_CALLBACK (gsm_manager_is_autostart_condition_handled), manager);
         g_signal_connect (skeleton, "handle-is-inhibited",
                           G_CALLBACK (gsm_manager_is_inhibited), manager);
         g_signal_connect (skeleton, "handle-is-session-running",
@@ -1954,18 +3222,18 @@ register_manager (GsmManager *manager)
         g_signal_connect (skeleton, "handle-unregister-client",
                           G_CALLBACK (gsm_manager_unregister_client), manager);
 
-        manager->dbus_disconnected = FALSE;
+        priv->dbus_disconnected = FALSE;
         g_signal_connect (connection, "closed",
                           G_CALLBACK (on_session_connection_closed), manager);
 
-        manager->connection = connection;
-        manager->skeleton = skeleton;
+        priv->connection = connection;
+        priv->skeleton = skeleton;
 
-        g_signal_connect (manager->system, "notify::active",
+        g_signal_connect (priv->system, "notify::active",
                           G_CALLBACK (on_gsm_system_active_changed), manager);
 
         /* cold-plug SessionIsActive */
-        on_gsm_system_active_changed (manager->system, NULL, manager);
+        on_gsm_system_active_changed (priv->system, NULL, manager);
 
         return TRUE;
 }
